import java.awt.Robot;
import java.awt.MouseInfo;
import java.awt.Color;
import java.awt.AWTException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.lang.Math;
import java.awt.event.KeyEvent;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;

public class Functions
{
    public static String LEFT = "Left: ";
    public static String RIGHT = "Right: ";
    public static String TOP = "Top: ";
    public static String BOTTOM = "Bottom: ";
    public static String FBUTTONWIDTH = "First Button Width: ";
    public static String BUTTONWIDTH = "Button Width: ";
    public static String BUTTONHEIGHT = "Button Height: ";
    public static String TIMERWIDTH = "Timer Width: ";
    public static String TIMERHEIGHT = "Timer Height: ";
    
    public static String SETUPFILE = "setup.txt";
    
    public static int UPLEFT=0;
    public static int UPRIGHT=1;
    public static int BOTLEFT=2;
    public static int BOTRIGHT=3;
    public static int CENTER=4;
    public static int OFFSET=5;
    public static int OFFSETB=6;
    public static int BUTTON=7;
    public static int ANVIL=8;
    public static int NONE=9;
    public static int WINONLY=10;
    public static int DEFAULT=NONE;
    
    public static int NORTH = 0;
    public static int NORTHEAST = 1;
    public static int EAST = 2;
    public static int SOUTHEAST = 3;
    public static int SOUTH = 4;
    public static int SOUTHWEST = 5;
    public static int WEST = 6;
    public static int NORTHWEST = 7;
    public static int ALLDIR = 8;

    private static float anvilSegWidth = (float)23.6;
    private static float anvilSegHeight = (float)23.4;
    
    private int left, right, top, bottom;
    private int[] center;
    private int firstButtonWidth, buttonWidth, buttonHeight;
    private int timerWidth, timerHeight;
    private int[] anvil;
    
    private int xOffset;
    private int yOffset;
    private int xOffsetB;
    private int yOffsetB;
    
    private int[] clear;
    
    private int Width;
    private int Height;
    private int NumberOfWindows;
    private int NumberOfCols;

    private int BWidth=0;
    private int BHeight=0;
    private int BNumberOfWindows=0;
    private int BNumberOfCols=0;
    
    private Robot robot;
    
    public Functions(int l, int u, int InputWidth, int InputHeight, int InputNOW, int InputNOC)
    {
	initFunctions(l,u,InputWidth,InputHeight,InputNOW,InputNOC,0,0,0,0,0,0);
    }

    public Functions(int l, int u, int InputWidth, int InputHeight, int InputNOW, int InputNOC, int l2, int u2, int InputWidth2, int InputHeight2, int InputNOW2, int InputNOC2)
    {
	initFunctions(l,u,InputWidth,InputHeight,InputNOW,InputNOC,l2,u2,InputWidth2,InputHeight2,InputNOW2,InputNOC2);
    }

    public Functions(int InputWidth, int InputHeight, int InputNOW, int InputNOC)
    {
	initFunctions(0,0,InputWidth,InputHeight,InputNOW,InputNOC,0,0,0,0,0,0);
    }
    
    public Functions()
    {
	initFunctions(0,0,0,0,0,0,0,0,0,0,0,0);
    }
    
    private void initFunctions(int offL, int offU, int InputWidth, int InputHeight, int InputNOW, int InputNOC, int l2, int u2, int InputWidth2, int InputHeight2, int InputNOW2, int InputNOC2)
    {
	BufferedReader r=null;
	String filename = SETUPFILE;
	String l;
	
	xOffset = offL;
	yOffset = offU;
        Width = InputWidth;
        Height = InputHeight;
        NumberOfWindows = InputNOW;
        NumberOfCols = InputNOC;

	xOffsetB = l2;
	yOffsetB = u2;
        BWidth = InputWidth2;
        BHeight = InputHeight2;
        BNumberOfWindows = InputNOW2;
        BNumberOfCols = InputNOC2;

	try {
            robot = new Robot();
        }
        catch (AWTException awte) {
            System.out.println("The Robot was not initialized "+awte + "\n");
        }
	

	left=0;
	right=0;
	top=0;
	bottom=0;
	firstButtonWidth=0;
	buttonWidth=64;
	buttonHeight=100;
	timerWidth=0;
	timerHeight=0;
	
	/*
	try {
	    r = new BufferedReader(new FileReader(filename));
	    
	    while( (l = r.readLine()) != null) {
		if(l.startsWith(LEFT))
		    left = new Integer(l.substring(LEFT.length())).intValue();
		else if(l.startsWith(RIGHT))
		    right = new Integer(l.substring(RIGHT.length())).intValue();
		else if(l.startsWith(TOP))
		    top = new Integer(l.substring(TOP.length())).intValue();
		else if(l.startsWith(BOTTOM))
		    bottom = new Integer(l.substring(BOTTOM.length())).intValue();
		else if(l.startsWith(FBUTTONWIDTH))
		    firstButtonWidth = new Integer(l.substring(FBUTTONWIDTH.length())).intValue();
		else if(l.startsWith(BUTTONWIDTH))
		    buttonWidth = new Integer(l.substring(BUTTONWIDTH.length())).intValue();
		else if(l.startsWith(BUTTONHEIGHT))
		    buttonHeight = new Integer(l.substring(BUTTONHEIGHT.length())).intValue();
		else if(l.startsWith(TIMERWIDTH))
		    timerWidth = new Integer(l.substring(TIMERWIDTH.length())).intValue();
		else if(l.startsWith(TIMERHEIGHT))
		    timerHeight = new Integer(l.substring(TIMERHEIGHT.length())).intValue();
	    }
	} catch (Exception e) {
	    System.out.println("Error reading file: " + e);
	} finally {
	    if(r != null)
		try {
		    r.close();
		} catch (Exception e) {
		    System.out.println("Error closing file: " + e);
		}
	}
	
	center = new int[2];
	center[0] = (left+right)/2;
	center[1] = (top+bottom)/2;
	*/
    }
    
    public void PressButton(int[] xy)
    {
	PressButton(DEFAULT, xy, 0, 0);
    }
    
    public void PressButton(int loc, int[] xy)
    {
	PressButton(loc, xy, 0, 0);
    }
    
    public void PressButton(int[] xy, int window)
    {
	PressButton(DEFAULT, xy, window, 0);
    }
    
    public void PressButton(int[] xy, int window, int delay)
    {
	PressButton(DEFAULT, xy, window, delay);
    }
    
    public void PressButton(int loc, int[] xy, int window) 
    {
	PressButton(loc, xy, window, 0);
    }

    public void PressButton(int loc, int[] xy, int window, int delay)
    {
	PressButtonDelay(ConvertCoords(loc, xy, window), delay);
    }
    
    public void SetClear(int[] xy)
    {
	if(xy.length == 2) {
	    clear = new int[2];
	    clear[0] = xy[0];
	    clear[1] = xy[1];
	}
    }
    
    public void SetAnvil(int[] xy)
    {
	anvil = new int[2];
	for(int i=0;i<2;i++) {
	    if(i<xy.length) {
		anvil[i] = xy[i];
	    } else {
		anvil[i] =0;
	    }
	}
    }
    
    int[] ConvertCoords(int loc, int[] xy, int window)
    {
	int[] newCoords = new int[2];
    	if( loc == UPLEFT ) {
	    newCoords[0] = (xy[0] + Width * (window % NumberOfCols)) + left;
	    newCoords[1] = (xy[1] + Height * (window / NumberOfCols)) + top;
	} else if( loc == UPRIGHT ) {
	    newCoords[0] = (xy[0] + Width * (window % NumberOfCols)) + right;
	    newCoords[1] = (xy[1] + Height * (window / NumberOfCols)) + top;
	} else if( loc == BOTLEFT ) {
	    newCoords[0] = (xy[0] + Width * (window % NumberOfCols)) + left;
	    newCoords[1] = (xy[1] + Height * (window / NumberOfCols)) + bottom;
	} else if( loc == BOTRIGHT ) {
	    newCoords[0] = (xy[0] + Width * (window % NumberOfCols)) + right;
	    newCoords[1] = (xy[1] + Height * (window / NumberOfCols)) + bottom;
	} else if( loc == CENTER ) {
	    newCoords[0] = (xy[0] + Width * (window % NumberOfCols)) + center[0];
	    newCoords[1] = (xy[1] + Height * (window / NumberOfCols)) + center[1];
	} else if( loc == OFFSET ) {
	    newCoords[0] = (xy[0] + Width * (window % NumberOfCols)) + xOffset;
	    newCoords[1] = (xy[1] + Height * (window / NumberOfCols)) + yOffset;
	} else if( loc == OFFSETB ) {
	    newCoords[0] = (xy[0] + BWidth * (window % BNumberOfCols)) + xOffsetB;
	    newCoords[1] = (xy[1] + BHeight * (window / BNumberOfCols)) + yOffsetB;
	} else if( loc == BUTTON ) {
	    newCoords[0] = xy[0] + left + firstButtonWidth + buttonWidth*window;
	    newCoords[1] = xy[1] + top;
	} else if( loc == ANVIL) {
	    newCoords[0] = Math.round(xy[0]*anvilSegWidth) + anvil[0] + left;
	    newCoords[1] = Math.round(xy[1]*anvilSegHeight - xy[0]%2*anvilSegHeight/2) + anvil[1];
	} else if( loc == NONE) {
	    newCoords[0] = xy[0];
	    newCoords[1] = xy[1];
	} else { //if(loc == WINONLY) {
	    if(NumberOfCols != 0) {
		newCoords[0] = xy[0] + Width * (window % NumberOfCols);
		newCoords[1] = xy[1] + Height * (window / NumberOfCols);
	    } else {
		newCoords[0] = xy[0];
		newCoords[1] = xy[1];
	    }
	}
	
	return newCoords;
    }
    
    private void PressButtonDelay(int[] xy, int delay)
    {
        robot.delay(delay);
        robot.mouseRelease(4);
        robot.mouseRelease(16);
        robot.mouseMove(xy[0], xy[1]);
        robot.delay(delay);
        robot.mousePress(4);
	robot.delay(1);
        robot.mouseRelease(4);
    }
    
    public void StopWalking()
    {
	robot.keyRelease(KeyEvent.VK_UP);
	robot.keyRelease(KeyEvent.VK_DOWN);
	robot.keyRelease(KeyEvent.VK_LEFT);
	robot.keyRelease(KeyEvent.VK_RIGHT);
    }
    
    public void StopWalking(int d)
    {
	if(d == NORTH)
	    robot.keyRelease(KeyEvent.VK_UP);
	else if(d == SOUTH)
	    robot.keyRelease(KeyEvent.VK_DOWN);
	else if(d == WEST)
	    robot.keyRelease(KeyEvent.VK_LEFT);
	else if(d == EAST)
	    robot.keyRelease(KeyEvent.VK_RIGHT);
	else if(d == ALLDIR) {
	    robot.keyRelease(KeyEvent.VK_UP);
	    robot.keyRelease(KeyEvent.VK_DOWN);
	    robot.keyRelease(KeyEvent.VK_LEFT);
	    robot.keyRelease(KeyEvent.VK_RIGHT);
	}

    }
    
    public void Walk(int d)
    {
	if(d == NORTH || d == NORTHEAST || d == NORTHWEST) {
	    //robot.keyRelease(KeyEvent.VK_UP);
	    robot.keyPress(KeyEvent.VK_UP);
	}
	if(d == SOUTH || d == SOUTHEAST || d == SOUTHWEST) {
	    //robot.keyRelease(KeyEvent.VK_DOWN);
	    robot.keyPress(KeyEvent.VK_DOWN);
	}
	if(d == EAST || d == SOUTHEAST || d == NORTHEAST) {
	    //robot.keyRelease(KeyEvent.VK_RIGHT);
	    robot.keyPress(KeyEvent.VK_RIGHT);
	}
	if(d == WEST || d == SOUTHWEST || d == NORTHWEST) {
	    //robot.keyRelease(KeyEvent.VK_LEFT);
	    robot.keyPress(KeyEvent.VK_LEFT);
	}
	   
    }

    public void Click()
    {
	robot.mouseRelease(4);
        robot.mouseRelease(16);
	robot.mousePress(4);
        robot.mouseRelease(4);
    }

    public void Drag(int startLoc, int[] startXY, int startWindow, int endLoc, int[] endXY, int endWindow)
    {
	int[] sXY = ConvertCoords(startLoc, startXY, startWindow);
	int[] eXY = ConvertCoords(endLoc, endXY, endWindow);
	robot.delay(100);
	robot.mouseMove(sXY[0], sXY[1]);
	robot.delay(100);
	robot.mousePress(4);
	robot.delay(100);
	robot.mouseMove(eXY[0], eXY[1]);
	robot.delay(100);
        robot.mouseRelease(4);
	robot.delay(100);
    }
    
    public void Type(int k) {
	robot.keyPress(k);
	robot.keyRelease(k);
    }
    
    public void Delay(int d){
	int factor = 1000;
	int major = d/factor;
	int minor = d%factor;
	int i;
	
	for(i=0;i<major;i++) {
	    robot.delay(factor);
	}
	robot.delay(minor);
    }

    public void Wait(){
	robot.waitForIdle();
    }

    public void Click(int button) {
	robot.mousePress(button);
        robot.mouseRelease(button);
    }
    
    public void MouseMove(int[] xy) {
	MouseMove(DEFAULT, xy, 0);
    }
    
    public void MouseMove(int loc, int[] xy) {
	MouseMove(loc, xy, 0);
    }
    
    public void MouseMove(int[] xy, int window) {
	MouseMove(DEFAULT, xy, window);
    }
    
    public void MouseMove(int loc, int[] xy, int window) 
    {
	ActualMouseMove(ConvertCoords(loc, xy, window));
    }
    
    private void ActualMouseMove(int[] xy)
    {
	robot.mouseMove(xy[0], xy[1]);
    }
    
    public Color GetPixelColor(int loc, int x, int y)
    {
	int[] xy = new int[2];
	xy[0] = x;
	xy[1] = y;
	
	return GetPixelColor(loc, xy);
    }
    
    public Color GetPixelColor(int[] xy)
    {
	return actualGetPixelColor(ConvertCoords(DEFAULT, xy, 0));
    }

    public Color GetPixelColor(int[] xy, int window)
    {
	return actualGetPixelColor(ConvertCoords(DEFAULT, xy, window));
    }

    public Color GetPixelColor(int loc, int[] xy)
    {
	return actualGetPixelColor(ConvertCoords(loc, xy, 0));
    }
    
    public Color GetPixelColor(int loc, int[] xy, int window)
    {
	return actualGetPixelColor(ConvertCoords(loc, xy, window));
    }
    
    private Color actualGetPixelColor(int[] xy)
    {
	return robot.getPixelColor(xy[0], xy[1]);
    }
    
    public Color GetPixelColor(int[] xy, BufferedImage bi)
    {
	return GetPixelColor(xy, 0, bi);
    }

    public Color GetPixelColor(int[] xy, int window, BufferedImage bi)
    {
	int[] tmp = ConvertCoords(WINONLY, xy, window);
	return new Color(bi.getRGB(tmp[0], tmp[1]));
    }
    
    public int[] GetMouseLocation()
    {
	return GetMouseLocation(DEFAULT, 0);
    }
    
    public int[] GetMouseLocation(int loc)
    {
	return GetMouseLocation(loc, 0);
    }
    
    public int[] GetMouseLocation(int loc, int window)
    {
	int[] xy = new int[2];
	int[] diff;

	xy[0]=MouseInfo.getPointerInfo().getLocation().x;
        xy[1]=MouseInfo.getPointerInfo().getLocation().y;
	
	diff = ConvertCoords(loc, xy, window);
	
	diff[0] -= xy[0];
	diff[1] -= xy[1];
	
	xy[0] -= diff[0];
	xy[1] -= diff[1];
	
	return xy;
    }
    
    public boolean compareColors(Color a, Color b)
    {
	return compareColors(a,b,15);
    }

    public boolean compareColors(Color a, Color b, int maxDif)
    {
	int dif = 0;
	
	dif += Math.abs(a.getRed() - b.getRed());
	dif += Math.abs(a.getGreen() - b.getGreen());
	dif += Math.abs(a.getBlue() - b.getBlue());
	
	if(dif < maxDif) {
	    return true;
	} else {
	    return false;
	}
    }
    
    public boolean compareColors(Color[] a, Color[] b)
    {
	return compareColors(a,b,15);
    }
    
    public boolean compareColors(Color[] a, Color[] b, int maxDif)
    {
	int i;
	for(i=0; i<a.length; i++) {
	    if(! compareColors(a[i], b[i]) ) {
		return false;
	    }
	}
	return true;
    }
    
    public boolean OpenWindow(int[] xy)
    {
	return OpenWindow(DEFAULT, xy, 0, true);
    }
    
    public boolean OpenWindow(int[] xy, int window)
    {
	return OpenWindow(DEFAULT, xy, window, true);
    }
    
    public boolean OpenWindow(int loc, int xy[])
    {
	return OpenWindow(loc, xy, 0, true);
    }
    
    public boolean OpenWindow(int[] xy, boolean canClear)
    {
	return OpenWindow(DEFAULT, xy, 0, canClear);
    }
    
    public boolean OpenWindow(int[] xy, int window, boolean canClear)
    {
	return OpenWindow(DEFAULT, xy, window, canClear);
    }
    
    public boolean OpenWindow(int loc, int xy[], boolean canClear)
    {
	return OpenWindow(loc, xy, 0, canClear);
    }

    public boolean OpenWindow(int loc, int xy[], int window)
    {
	return OpenWindow(loc, xy, window, true);
    }

    private int delayAdjust=100, openCount=0, openFail=0, minCount=40;
    public boolean OpenWindow(int loc, int[] xy, int window, boolean canClear)
    {
	int[] windowCheck = new int[2];
	windowCheck[0] = xy[0] + 1;
	windowCheck[1] = xy[1];
	
	int failures = 0, maxFailures = 6;
	int wait = 0, maxWait = 10;
	
	boolean loop = true, first = true;
	
	int[] mouse;
	
	int[] jitter = new int[2];
	jitter[0] = clear[0]-1;
	jitter[1] = clear[1];

	while(loop) {
	    if(wait < maxWait && !first) {
		wait++;
		Delay(50);
	    } else if(failures > maxFailures) {
		failures = 0;
		if(!canClear) {
		    return false;
		}
		if(openCount < minCount) {
		    delayAdjust += 10;
		}
		Delay(10*1000);
	    } else {
		wait=0;
		failures++;
		if(!first)
		    openFail++;
		openCount++;
		mouse = GetMouseLocation();
		if(canClear) {
		    PressButton(jitter);
		    Delay(delayAdjust);
		    PressButton(clear);
		}
		PressButton(loc, xy, window, delayAdjust);
		MouseMove(mouse);
	    }
	    
	    first = false;
	    
	    if(IsWindowOpen(loc, xy, window)) {
		return true;
	    }
	    
	    if(openCount >= minCount) {
		if(openFail*10/openCount >= 2) {
		    delayAdjust += 10;
		    openFail=0;
		    openCount=0;
		} else if(openFail*100/openCount == 0 && delayAdjust > 10) {
		    delayAdjust -= 10;
		    openFail=0;
		    openCount=0;
		}
	    }
	}
	return false;
    }
    
    public boolean IsWindowOpen(int[] xy)
    {
	return IsWindowOpen(DEFAULT, xy, 0);
    }

    public boolean IsWindowOpen(int[] xy, int window)
    {
	return IsWindowOpen(DEFAULT, xy, window);
    }

    public boolean IsWindowOpen(int loc, int[] xy)
    {
	return IsWindowOpen(loc, xy, 0);
    }
    
    public boolean IsWindowOpen(int loc, int[] xy, int window)
    {
	Color color = new Color(112,79,46);
	int[] check = new int[2];
	check[0] = xy[0] + 1;
	check[1] = xy[1];
	
	Color color2 = new Color(148, 108, 70);
	int[] check2 = new int[2];
	check2[0] = xy[0] + 2;
	check2[1] = xy[1];
		
	return compareColors(color, GetPixelColor(loc, check, window)) && compareColors(color2, GetPixelColor(loc, check2, window));
    }
    
    public BufferedImage ScreenCap(int[] xy, int width, int height)
    {
	return ScreenCap(DEFAULT, xy, 0, width, height);
    }

    public BufferedImage ScreenCap(int loc, int[] xy, int width, int height)
    {
	return ScreenCap(loc, xy, 0, width, height);
    }

    public BufferedImage ScreenCap(int[] xy, int window, int width, int height)
    {
	return ScreenCap(DEFAULT, xy, window, width, height);
    }
    
    public BufferedImage ScreenCap(int loc, int[] xy, int window, int width, int height)
    {
	int[] tmp = ConvertCoords(loc, xy, window);
	return robot.createScreenCapture(new Rectangle(tmp[0], tmp[1], width, height));
    }
}