import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
import javax.swing.KeyStroke;
import java.util.LinkedList;
import java.lang.Exception;

public class MacrosPane extends JPanel implements ActionListener
{
    protected static JMenuBar menuBar;
    protected static JFrame frame;
    
    private static String[] miningNames = {"Iron", "Copper", "Tin", "Lead", "Antimony", "Aluminum", "Silver", "Zinc", "Titanium", "Magnisium"};
    
    private JMenu menu;
    private JMenu menuMining;
    
    //private LinkedList<String> items = new LinkedList<String>();
    
    public MacrosPane()
    {
	JLabel label;
	int i;
	
	menuBar = new JMenuBar();
	
	menuMining = new JMenu("Mining");
	menuMining.setMnemonic(KeyEvent.VK_M);
	//menu.getAccessibleContext().setAccessibleDescription("something");
	menuBar.add(menuMining);
	
	//menuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_1, ActionEvent.ALT_MASK));
	
	for(i=0; i<miningNames.length; i++) {
	    addMenuItem(miningNames[i], menuMining);
	}

	frame.setJMenuBar(menuBar);
	label = new JLabel("Select a macro from the \"Mining\" menu.\n");
	label.setHorizontalAlignment(JLabel.LEFT);
	add(label);
    }
    
    private void addMenuItem(String s, JMenu menu)
    {
	JMenuItem menuItem;

	menuItem = new JMenuItem(s);
	menuItem.setActionCommand(s);
	menuItem.addActionListener(this);
	menu.add(menuItem);
	//items.add(s);
    }
    
    public void actionPerformed(ActionEvent e) {
	try {
	    Macro macro;
	    macro = (Macro)Class.forName(e.getActionCommand()).newInstance();
	    
	    new Thread(macro).start();
	} catch(Exception exp) {
	    System.out.println("Failed to start a new thread: " + exp.toString());
	}
    }
    
    // Create the GUI and show it.
    private static void createGUI() {
	JFrame.setDefaultLookAndFeelDecorated(true);
	// Create and set up the frame.
	frame = new JFrame("ATITD Macros");
	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	
	// Create and set up the content pane.
	MacrosPane mainPain = new MacrosPane();
	mainPain.setOpaque(true);
	//frame.getRootPane().setDefaultButton(jbnMiddle);
	frame.setContentPane(mainPain);
	
	// Display the window.
	frame.pack();
	frame.setVisible(true);
    }
    public static void main(String[] args) {
	javax.swing.SwingUtilities.invokeLater(new Runnable() {
		public void run() {
		    createGUI();
		}
	    });
    }
}