import java.awt.Color;

public class Mining extends Macro
{
    private boolean input = true;
    private boolean nonInput = true;
    
    private int count=0;
    private static String[] words = {"first", "second", "third", "fourth", "fifth", "sixth", "seventh"};
    public static int NUMCRYSTALS = words.length;
    private int maxCount = words.length;
    
    private AlgMine alg;
    private Functions functions;
    
    private String[] labels = new String[3];
    
    private int level = 0;
    private int stop;
    
    private int coords[][] = new int[maxCount][];
    private Color colors[] = new Color[maxCount];
    private Color oldColors[] = new Color[maxCount];
    
    private int[] popUpOkButton = {-8, 98};
    private Color popUpOkColor = new Color(0, 0, 0);
    
    private StatWatcher stat;
    
    private boolean start=true, clearDef=false, okDef=false, crystalStart=false;
    
    public Mining(AlgMine algorithm)
    {
	alg = algorithm;
	functions = new Functions();
    }
    
    public void noInput()
    {
	input = false;
	run();
    }
    
    public void setArgs(int[] args)
    {
	if(args.length == 2) {
	    if(level == 0) {
		level = args[0];
	    }
	    stop = args[1];
	}
    }
    
    public void setLevel(int l) {
	level = l;
    }
    
    public void run()
    {
	labels = new String[1];
	
	if(input) {
	    if(start) {
		start=false;
		String[] labels = new String[3];
		labels[0] = "Enter your mining level: ";
		labels[1] = "How many pulls before stopping (enter a negative number for no stop): ";
		labels[2] = "Place your cursor over the ground/sky.";
		int[] defaults = {5,-1};
		new PromptWindow(labels, this, 2, defaults);
	    } else if(!clearDef) {
		clearDef = true;
		functions.SetClear(functions.GetMouseLocation());
		stat = new StatWatcher(this, "Strength or Perception, which ever stat is lower", 250);
		/*labels[0] = "Place your cursor over the ATITD \"OK\" button in the popup window for needing to wait for a stat to recover, then hit \"enter\".";
		new PromptWindow(labels, this);
	    } else if(!okDef) {
		okDef=true;
		popUpOkButton = functions.GetMouseLocation();
		popUpOkColor = functions.GetPixelColor(popUpOkButton); */
	    } else if(crystalStart) {
		coords[count] = functions.GetMouseLocation();
		count++;
	    }
	    
	    if(okDef && count<maxCount) {
		crystalStart=true;
		labels[0] = "Place your cursor over the " + words[count] + " crystal and hit \"enter\".";
		new PromptWindow(labels, this);
	    }
	    if(clearDef) {
		okDef=true;
	    }
	}
	

	if(nonInput && (count>=maxCount || !input)) {
	    mine();
	}
    }
    
    private void mine()
    {
	int i, j;
	int[] history = new int[level];
	int place = 0;
	int c=0;
	int stall=0;
	
	for(j=0;j<level;j++) {
	    history[j] = 0;
	}
	
	for(j=0;j<maxCount;j++) {
	    oldColors[j] = new Color(0,0,0);
	    colors[j] = functions.GetPixelColor(coords[j]);
	}
	
	for(i=0; i<stop || stop<0; i++) {
	    stall=0;
	    while(functions.compareColors(colors, oldColors)) {
		functions.Delay(50);
		updateColors();
		stall++;
		if(stall%100 == 0) {
		    System.out.println("Stalled waiting for color change.");
		    functions.Delay(1000*10);
		} else if(stall%40==0 && stat.ready()) {
		    work(c);
		    //place = (place + 1) % level;
		}
	    }

	    updateColors(); // Make sure all the colors are up-to-date
	    for(j=0;j<maxCount;j++) {
		oldColors[j] = colors[j]; // Set old Colors to the new colors
	    }
	    
	    c = alg.choose(colors, history, place);
	    System.out.println("");
	    
	    while(!stat.ready()) {
		functions.Delay(50);
	    }
	    work(c);
	    place = (place + 1) % level;
	    
	    // check for pop up. close pop up, wait tell it's gone. check for change, if no change re-work 'c'
	    /*while(true) {
		functions.Delay(1000);
		if(checkPopUp()) {
		    closePopUp();
		    stall=0;
		    while(checkPopUp()) {
			stall++;
			if(stall%100 == 0) {
			    System.out.println("Stalled waiting for pop up to close.");
			    functions.Delay(1000*10);
			} else if(stall%10==0) {
			    closePopUp();
			}
			functions.Delay(50);
		    }
		    
		    updateColors();
		    if(functions.compareColors(colors, oldColors)) {
			work(c);
		    } else {
			break;
		    }
		} else {
		    break;
		}
	    }
	    */
	}
    }
    
    
    private boolean checkPopUp()
    {
	if( functions.compareColors( popUpOkColor, functions.GetPixelColor(popUpOkButton)) ) {
	    return true;
	} else {
	    return false;
	}
    }
    
    private void closePopUp()
    {
	int[] mouse;
	
	mouse = functions.GetMouseLocation();
	functions.PressButton(popUpOkButton, 0);
	functions.MouseMove(mouse);
    }
    
    private void updateColors()
    {
	int j;
	for(j=0;j<maxCount;j++) {
	    colors[j] = functions.GetPixelColor(coords[j]);
	}
    }
    
    private void work(int crystal)
    {
	int[] mouse;
	int[] loc = new int[2];
	int i;
	int x = 10, startY = 0, changeY = -8, workDistance = 11;
	Color c = new Color(120, 111, 84);
	
	loc[0] = coords[crystal][0] + x;
	loc[1] = coords[crystal][1] + startY;
	
	functions.OpenWindow(coords[crystal]);
	
	for(i=0;i<4;i++) {
	    if(functions.compareColors(c, functions.GetPixelColor(loc))) {
		break;
	    } else {
		loc[1] += changeY;
	    }
	}
	
	loc[1] += workDistance;
	
	mouse = functions.GetMouseLocation();
	functions.PressButton(loc);
	functions.MouseMove(mouse);
	
	/*
	int stall=0;
	while( functions.IsWindowOpen(coords[crystal]) ) {
	    stall++;
	    
	    if(stall%100==0) {
		System.out.println("Stalled waiting for work window to close.");
	    } else if (stall%10==0) {
		mouse = functions.GetMouseLocation();
		functions.PressButton(loc);
		functions.MouseMove(mouse);
	    }
	    functions.Delay(50);
	}
	*/
    }
}