import java.awt.image.BufferedImage;

public class StatWatcher extends Macro
{
    private Functions functions;
    private int threshold;
    private static int defaultThreshold = 10;
    private int[] pointXY = null;    
    private String statName;
    private Macro macro;
    
    public StatWatcher(Macro m)
    {
	init(m, "stat", defaultThreshold);
    }

    public StatWatcher(Macro m, String stat)
    {
	init(m, stat, defaultThreshold);
    }
    
    public StatWatcher(Macro m, int t)
    {
	init(m, "stat", t);
    }
    
    public StatWatcher(Macro m, String stat, int t)
    {
	init(m, stat, t);
    }
    
    private void init(Macro m, String stat, int t)
    {
	macro = m;
	statName = stat;
	functions = new Functions();
	threshold = t;
	run();
    }
    
    private int[] a, b;
    private boolean aDef=false, bDef=false, pointDef=false;
    public void run()
    {
	String lables[] = new String[1];
	if(input && !aDef) {
	    aDef=true;
	    lables[0] = "Place your cursor over the word " + statName +  ".";
	    new PromptWindow(lables, this);
	} else if(input && !bDef) {
	    bDef=true;
	    a = functions.GetMouseLocation();
	    lables[0] = "Move your cursor some where else over the word " + statName +  ".";
	    new PromptWindow(lables, this);
	} else if(input && !pointDef) {
	    pointDef = true;
	    b = functions.GetMouseLocation();

	    //System.out.println("A: " + a[0] + ", " + a[1]);
	    //System.out.println("B: " + b[0] + ", " + b[1]);
	    
	    pointXY = findPoint(a,b);
	    if(pointXY == null) {
		aDef=false;
		bDef=false;
		pointDef=false;
		lables[0] = "Try again, make sure there is a black pixel in";
		new PromptWindow(lables, this);
	    } else {
		macro.run();
	    }
	}
    }

    private int[] findPoint(int[] a, int[] b)
    {
	int[] tl = new int[2];
	int[] result = new int[2];
	int width, height;
	int i,j;
	int minX, minY, maxX, maxY;
	BufferedImage screen;
	
	minX = min(a[0], b[0]);
	minY = min(a[1], b[1]);
	maxX = max(a[0], b[0]);
	maxY = max(a[1], b[1]);
	
	tl[0] = minX;
	tl[1] = minY;
	width = maxX - minX;
	height = maxY - minY;
	
	//System.out.println("" + minX + ", " + maxX+ ", " + minY + ", " + maxY);
	
	screen = functions.ScreenCap(tl, width, height);

	for(result[0] = 0; result[0] < width; result[0]++) {
	    for(result[1] = 0; result[1] < height; result[1]++) {
		//System.out.println("" + result[0] + ", " + result[1] + ": " + functions.GetPixelColor(result, screen));
		if(functions.GetPixelColor(result, screen).getGreen() < 8) {
		    result[0] += tl[0];
		    result[1] += tl[1];
		    return result;
		}
	    }
	}
	return null;
    }
    
    private int min(int a, int b)
    {
	if(a>b)
	    return b;
	else
	    return a;
    }
    
    private int max(int a, int b)
    {
	if(a<b)
	    return b;
	else
	    return a;
    }
    
    public boolean ready()
    {
	if(pointXY == null) {
	    return false;
	} else {
	    return functions.GetPixelColor(pointXY).getRed() < threshold;
	}
    }
}
